///////////////////////////////////////////////////////////////////////////////////////////
// Authors: Eva Bunodiere, Yasmin Kossak
// ShowFilesDialog.cpp
// ShowFilesDialog Class Function Definitions
// JPC36 Wx-View 
// July 25th 2000
// Technical Advisor : Carlos Moreno
///////////////////////////////////////////////////////////////////////////////////////////

#include "ShowFilesDialog.h"

#include "wx-view.h"

#include <sstream>
#include <vector>
using namespace std;

/******************************************************************************************
	Function: ShowFilesDialog::ShowFilesDialog
	Receives: N/A (constructor)
	Returns: N/A (constructor)
	Description: 
		Calls the wxDialog constructor to create a new show files dialog for the application.
		Resizes the Dialog after placing the controls to ensure correct positioning. Adds Cancel
		and OK buttons to dismiss the dialog.
*******************************************************************************************/
ShowFilesDialog::ShowFilesDialog(wxWindow * parent, wxWindowID id, const wxString &title,
                                    vector <wxString> file_list)
    : wxDialog (parent, id, title, wxDefaultPosition, wxSize(275, 150))
{
    const int margin = 20;

    ostringstream buffer;

    vector <string> temp_vect;

     for (int i  = 0; i < file_list.size(); i++)
    {
        buffer << (file_list[i].c_str());

        if ( i < file_list.size() - 1)
            buffer << "\n";
    }

    string temp = buffer.str();
	
	// Place all controls in positions relative to the previously created controls

	files_label = new wxStaticText(this, -1, temp.c_str(), wxPoint(margin, margin));
	
	const int x_ok = files_label->GetRect().GetRight() + 20;
    ok = new wxButton(this, wxID_OK, translation["OK"], wxPoint(x_ok, margin));

	int w, h, client_w, client_h;
	GetSize (&w, &h);
	GetClientSize (&client_w, &client_h);
	
	const int dx = w - client_w;
	const int dy = h - client_h;
	
	const int width = ok->GetRect().GetRight() + margin + dx;
	const int height = files_label->GetRect().GetBottom() + margin + dy;
	
	SetSize (width, height);
	CentreOnParent(wxBOTH);
}
