///////////////////////////////////////////////////////////////////////////////////////////
// Authors: Eva Bunodiere, Yasmin Kossak
// ZoomSettingsDialog.h
// ZoomSettingsDialog Class Declaration
// JPC36 Wx-View
// July 25th 2000
// Technical Advisor : Carlos Moreno
///////////////////////////////////////////////////////////////////////////////////////////

#ifndef __ZOOM_SETTINGS_DIALOG_H__
#define __ZOOM_SETTINGS_DIALOG_H__

#include "wx/wxprec.h"

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
#include "wx/wx.h"
#endif

#include "wx/dialog.h"
#include "canvas.h"

class ZoomSettingsDialog : public wxDialog
{
public:
    ZoomSettingsDialog(wxWindow * parent, wxWindowID id, const wxString &title, double saved_zoom_factor, bool saved_zoom_type);
    double zoom_factor() const;
    bool zoom_by_interpolation() const;

private:
    wxButton * ok;
    wxButton * cancel;
    wxStaticText * zoom_factor_label;
    wxRadioBox * zoom_choices;
    wxTextCtrl * zoom_factor_choice;
};

#endif		// !def __ZOOM_SETTINGS_DIALOG_H__
