/*********************************************************************************************************

Programmers:			Thalia Lewis and Muhammad Zulfigar
filename:: 				catdialog.h
						Contains class definition of Class CatDialog
Date:					August 8, 2000

**********************************************************************************************************/

#ifndef __CATDIALOG_H__
#define __CATDIALOG_H__

#include "wx/wxprec.h"

#ifdef __BORLANDC__
  #pragma hdrstop
#endif

#ifndef WX_PRECOMP
#include "wx/wx.h"
#endif

#include "imagedialog.h"
#include "category_treectrl.h"
#include <wx/treectrl.h>
#include <wx/menu.h>
#include <wx/string.h>

#include <vector>
using namespace std;


enum
{
    ID_category_tree = 50,
    ID_delete_file,
};


class CatDialog : public ImageDialog
{
public:
	CatDialog(wxWindow* parent, wxWindowID id, const wxString& title, const wxPoint& pos,
			const wxSize& size, const wxString & map_filename, const wxString & config_dir,
			 int icon_size);
	
	void OnItemActivated(wxTreeEvent& event);
	void OnDeleteFile(wxCommandEvent &);
	void display_image_icons(const vector<wxString> & image_names);	
	void get_image_icons(vector <wxString> & image_names, const wxTreeItemId & selected_id);
	void refresh_image_icons(const wxTreeItemId & selected_id);
	
private:
    DECLARE_EVENT_TABLE()
};

#endif
