/*******************************************************************************************************

Programmers:	Muhammad Zulfigar, 		Thalia Lewis
filename::		 category.h
				Includes definition of Category class
Date:			August 8, 2000

*********************************************************************************************************/

#ifndef __CATEGORY__H_
#define __CATEGORY__H_

#include <wx/treectrl.h>

#include <string>
#include <vector>
using namespace std;

class Category
{

public:
	Category(const string & name)
		: name(name)
	{}
	
	void add_file(const string & file_name, const wxTreeItemId &selected_id);
	void add_subcategory(const string & new_subcategory_name, const wxTreeItemId & selected_id);
	void fill_categories(const vector<string> & lines, int & current_line);	
	const Category * find_id (const wxTreeItemId & selected_id) const;
	Category * find_id (const wxTreeItemId & selected_id);	
	void format_category_file(vector <string> &lines, string spaces);	
	const vector<string> & get_files() const;
    const vector <string> &get_files(const wxTreeItemId & id)const;
	const string & get_name() const;
	const string & get_name(const wxTreeItemId & selected_id)const;	
	vector<Category> & get_subcategories();
	const vector<Category> & get_subcategories() const;		
	const vector<string> get_filenames(const string & line);
    void modify_category(const string & new_name, const wxTreeItemId &id);
    void remove_file(const string & file_name, const wxTreeItemId & selected_id);
    void remove_subcategory(const wxTreeItemId & parent_id, const wxTreeItemId & selected_id);
    void set_tree_id(const wxTreeItemId & id);

private:	
	string name;
 	vector<string> files;           //vector that holds paths to files belonging to the Category
  	vector<Category> subcategories; /*vector that holds other Category objects that are subcategories
 									belonging to the Category*/
  	wxTreeItemId category_tree_id; /*stores the id that associates this Category object with a certain
  								   item on a wxTreeCtrl*/
};

#endif
