/********************************
dirtreectrl.cpp
Mike MacIntyre, David Boys
Function definitions for Class DirTreeCtrl
last updated : August 9, 2000
*********************************/

#include "dirtreectrl.h"

///// FUNCTION DEFINITIONS /////

// *** DirTreeCtrl Class ***

/**********************************************************************
   Function: DirTreeCtrl::DirTreeCtrl
   Receives: wxWindow *, const wxWindowID
   Returns:  N/A (Constructor)
   Description: Constructs a custom wxTreeCtrl, to manipulate a
   				directory tree
**********************************************************************/
DirTreeCtrl::DirTreeCtrl (wxDialog* parent, const wxWindowID id)
 			 :wxTreeCtrl(parent, id, wxDefaultPosition, wxDefaultSize, wxSUNKEN_BORDER)
{
    wxTreeItemId  rootID;
    rootID = AddRoot("/", -1, -1);

    wxDir dir("/");
    if (dir.IsOpened())
    {
		add_branch(rootID, "/");
	}
}

/**********************************************************************
   Function: DirTreeCtrl::add_branch
   Receives: const wxTreeItemId &, const wxString &
   Returns:  void
   Description: Adds branches of directories to the tree control,
   				one branch per function call
**********************************************************************/
void DirTreeCtrl::add_branch(const wxTreeItemId & parent, const wxString & path)
{
	wxLogNull no_message;
	
    wxDir parent_dir;
    if(parent_dir.Open(path))
    {
    	wxString filename;
        bool cont = parent_dir.GetFirst(&filename, wxEmptyString, wxDIR_DIRS | wxDIR_HIDDEN);
        while ( cont )
        {
       		wxTreeItemId id = AppendItem(parent, filename, -1, -1);
            cont = parent_dir.GetNext(&filename);

        }
    }
}

