
#include "settings.h"

#include "wx/wxprec.h"

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
#include "wx/wx.h"
#endif

#include <iostream>
#include <fstream>
#include <cstdlib>
#include <cmath>
using namespace std;

User_preferences::User_preferences()
{
    fullpath = get_fullpath();

    initial_working_directory = wxGetCwd().c_str();

#ifdef __linux__    	
    ifstream config_file ((fullpath + "/" + LINUX_FILENAME).c_str());
#else
    ifstream config_file ((fullpath + "/" + MSW_FILENAME).c_str());
#endif

	bool file_read = false;
    	
	if (config_file)
	{
		string lang;    // ignore this -- translator module handles this
		getline (config_file, lang);
    		
		string line;
		getline (config_file, line);
		interval = atoi(line.c_str());

		getline (config_file, line);
		zoom_factor = atof(line.c_str());
		
		getline (config_file, line);
		zoom_type = atoi(line.c_str());

		getline (config_file, line);
		view_toolbar = atoi(line.c_str());
    		
		getline(config_file, filename);
    		
		getline (config_file, line);
		icon_size = atoi(line.c_str());
    		
		file_read = true;
	}

	if(!file_read)
	{
		interval = 4000;
		zoom_factor = 1.4142;
		zoom_type = true;
		view_toolbar = true;
//		sweep_type = 1;
		filename = "icon_list.txt";
	    icon_size = 32;
	}
}


void User_preferences::write_to_file (const string & lang)
{
#ifdef __linux__    	
    ofstream config_file ((fullpath + "/" + LINUX_FILENAME).c_str());
#else
    ofstream config_file ((fullpath + "/" + MSW_FILENAME).c_str());
#endif

	if(config_file)
	{
		config_file << lang << endl;
		config_file << interval << endl;
		config_file << zoom_factor << endl;
		config_file << zoom_type << endl;
		config_file << view_toolbar << endl;
//		config_file << sweep_type << endl;    (maybe in version 1.1?)
		config_file << filename << endl;
		config_file << icon_size << endl;
	}
}


string get_fullpath (const string & env_var)
{
    const char * const DIR = getenv (env_var.c_str());

    if (DIR != NULL)
    {
        return DIR;
    }
    else
    {
        cout << "Warning: Environment variable `" << ENV_VAR << "' not set.  Assuming `"
             << wxGetHomeDir() << "'\n";

        return wxGetHomeDir().c_str();
    }
}
